Codeforces Round 899 (Div. 2)(C手玩? D换根dp+贪心)

2023-12-05 19:28

本文主要是介绍Codeforces Round 899 (Div. 2)(C手玩? D换根dp+贪心),希望对大家解决编程问题提供一定的参考价值,需要的开发者们随着小编来一起学习吧!

A - Increasing Sequence

直接从1开始模拟就行


#include<bits/stdc++.h>
using namespace std;
const int N =2e5+10,mod=998244353;
#define int long long
typedef long long LL;
typedef pair<int, int> PII;
const long long inf=1e17;
using node=tuple<int,int,int>;
int n,m,k;
int a[N];
void solve()
{cin>>n;for(int i=1;i<=n;i++) cin>>a[i];int idx=1;for(int i=1;i<=n;i++){if(idx==a[i]) idx++;idx++;}cout<<idx-1<<"\n";
}signed main()
{cin.tie(0);cout.tie(0);ios::sync_with_stdio(0);int t=1;cin>>t;while(t--) solve();
}

B - Sets and Union

我看着范围小直接枚举缺哪个数的时候能选的最大值即可


#include<bits/stdc++.h>
using namespace std;
const int N =2e5+10,mod=998244353;
#define int long long
typedef long long LL;
typedef pair<int, int> PII;
const long long inf=1e17;
using node=tuple<int,int,int>;
int n,m,k;
int a[N];
void solve()
{cin>>n;set<int> st;vector<set<int>> a(n+1); for(int i=1;i<=n;i++){cin>>m;for(int j=0;j<m;j++){int x;cin>>x;a[i].insert(x);st.insert(x);}}int res=0;for(auto x:st){set<int> mp;for(int i=1;i<=n;i++){if(a[i].count(x)) continue;for(auto y:a[i]) mp.insert(y);}res=max(res,(int)(mp.size()));}cout<<res<<"\n";
}signed main()
{cin.tie(0);cout.tie(0);ios::sync_with_stdio(0);int t=1;cin>>t;while(t--) solve();
}

C:

老规矩:操作题先想操作有啥性质

考虑到从后往前选数字是不会对前面的数字造成影响的,我们可以不停先删去奇数编号大于0的数字,这样子剩下大于0的数字全部为偶数编号,如果第一个数字 ≥ 0显然,我们可以在取完第一个数字后使得偶数编号变为奇数编号,如果第二个数字 ≤ 0我们可以删去它使得后面的奇偶序翻转,但当第一个数字小于0,第二个数字大于0的时候,我们要考虑舍弃第二个数字的贡献还是选择第一个负数(容易发现对这两个数字操作改变奇偶的代价是最小的)。


#include<bits/stdc++.h>
using namespace std;
const int N =2e5+10,mod=998244353;
#define int long long
typedef long long LL;
typedef pair<int, int> PII;
const long long inf=1e17;
using node=tuple<int,int,int>;
int n,m,k;
int a[N];
void solve()
{cin>>n;vector<int> suf(n+10);int res=0;for(int i=1;i<=n;i++) cin>>a[i];for(int i=3;i<=n;i++){res+=max(0ll,a[i]);}int t;if(n>=2) t=max(a[1],a[1]+a[2]);else t=a[1];cout<<max(res,res+t)<<"\n";
}signed main()
{cin.tie(0);cout.tie(0);ios::sync_with_stdio(0);int t=1;cin>>t;while(t--) solve();
}

D:

首先一眼换根dp和最优点选的值最后肯定是根的值

为啥呢

首先我们无论怎么选,都要让当前叶子节点先变成和他父节点的值一样

这样就算父节点改变了,他的子树也不会改变

否则,如果让父节点变成叶子节点,如果父节点的祖宗节点改变了,那么父节点的子树也可能要改变,会增加额外次数

然后就是为啥选根为最后相等的值

图:

上面为选根,下面选3点

感性理解一下,就是如果根确定了,你变成其他值,其他值得系数会增加

然后就换根dp了,

预处理出1点的贡献

我是分成三部分得

  1. res[u]=w[u]-sz[u]*(a[fa]^a[u]) 当前点为子树得代价
  2. +(res[fa]-w[u]) 父亲节点的子节点的代价
  3. +(n-sz[u])*(a[fa]^a[u]) 父亲节点到当前点的代价
    
    #include<bits/stdc++.h>
    using namespace std;
    const int N =2e5+10,mod=998244353;
    #define int long long
    typedef long long LL;
    typedef pair<int, int> PII;
    const long long inf=1e17;
    using node=tuple<int,int,int>;
    int n,m,k;
    int a[N];
    vector<int> g[N];
    int res[N];
    int sz[N];
    int w[N];
    void dfs(int u,int fa)
    {sz[u]=1;for(auto v:g[u]){if(v==fa) continue;dfs(v,u);sz[u]+=sz[v];w[u]+=w[v];}w[u]+=sz[u]*(a[u]^a[fa]);res[1]+=sz[u]*(a[u]^a[fa]);
    }
    void dfs1(int u,int fa){res[u]=w[u]-sz[u]*(a[fa]^a[u])+(res[fa]-w[u])+(n-sz[u])*(a[fa]^a[u]);  for(auto v:g[u]){if(fa==v) continue;dfs1(v,u);}
    }
    void solve()
    {cin>>n;for(int i=1;i<=n;i++){cin>>a[i];g[i].clear();res[i]=w[i]=0;}for(int i=1;i<n;i++){int x,y;cin>>x>>y;g[x].emplace_back(y);g[y].emplace_back(x);}dfs(1,1);//  for(int i=1;i<=n;i++) cout<<w[i]<<" \n"[i==n];dfs1(1,1);for(int i=1;i<=n;i++) cout<<res[i]<<" \n"[i==n];
    }signed main()
    {cin.tie(0);cout.tie(0);ios::sync_with_stdio(0);int t=1;cin>>t;while(t--) solve();
    }

这篇关于Codeforces Round 899 (Div. 2)(C手玩? D换根dp+贪心)的文章就介绍到这儿,希望我们推荐的文章对编程师们有所帮助!



http://www.chinasem.cn/article/458825

相关文章

hdu4826(三维DP)

这是一个百度之星的资格赛第四题 题目链接:http://acm.hdu.edu.cn/contests/contest_showproblem.php?pid=1004&cid=500 题意:从左上角的点到右上角的点,每个点只能走一遍,走的方向有三个:向上,向下,向右,求最大值。 咋一看像搜索题,先暴搜,TLE,然后剪枝,还是TLE.然后我就改方法,用DP来做,这题和普通dp相比,多个个向上

hdu1011(背包树形DP)

没有完全理解这题, m个人,攻打一个map,map的入口是1,在攻打某个结点之前要先攻打其他一个结点 dp[i][j]表示m个人攻打以第i个结点为根节点的子树得到的最优解 状态转移dp[i][ j ] = max(dp[i][j], dp[i][k]+dp[t][j-k]),其中t是i结点的子节点 代码如下: #include<iostream>#include<algorithm

hdu4865(概率DP)

题意:已知前一天和今天的天气概率,某天的天气概率和叶子的潮湿程度的概率,n天叶子的湿度,求n天最有可能的天气情况。 思路:概率DP,dp[i][j]表示第i天天气为j的概率,状态转移如下:dp[i][j] = max(dp[i][j, dp[i-1][k]*table2[k][j]*table1[j][col] )  代码如下: #include <stdio.h>#include

usaco 1.3 Barn Repair(贪心)

思路:用上M块木板时有 M-1 个间隙。目标是让总间隙最大。将相邻两个有牛的牛棚之间间隔的牛棚数排序,选取最大的M-1个作为间隙,其余地方用木板盖住。 做法: 1.若,板(M) 的数目大于或等于 牛棚中有牛的数目(C),则 目测 给每个牛牛发一个板就为最小的需求~ 2.否则,先对 牛牛们的门牌号排序,然后 用一个数组 blank[ ] 记录两门牌号之间的距离,然后 用数组 an

usaco 1.1 Broken Necklace(DP)

直接上代码 接触的第一道dp ps.大概的思路就是 先从左往右用一个数组在每个点记下蓝或黑的个数 再从右到左算一遍 最后取出最大的即可 核心语句在于: 如果 str[i] = 'r'  ,   rl[i]=rl[i-1]+1, bl[i]=0 如果 str[i] = 'b' ,  bl[i]=bl[i-1]+1, rl[i]=0 如果 str[i] = 'w',  bl[i]=b

uva 10154 DP 叠乌龟

题意: 给你几只乌龟,每只乌龟有自身的重量和力量。 每只乌龟的力量可以承受自身体重和在其上的几只乌龟的体重和内。 问最多能叠放几只乌龟。 解析: 先将乌龟按力量从小到大排列。 然后dp的时候从前往后叠,状态转移方程: dp[i][j] = dp[i - 1][j];if (dp[i - 1][j - 1] != inf && dp[i - 1][j - 1] <= t[i]

uva 10118 dP

题意: 给4列篮子,每次从某一列开始无放回拿蜡烛放入篮子里,并且篮子最多只能放5支蜡烛,数字代表蜡烛的颜色。 当拿出当前颜色的蜡烛在篮子里存在时,猪脚可以把蜡烛带回家。 问最多拿多少只蜡烛。 代码: #include <iostream>#include <cstdio>#include <cstdlib>#include <algorithm>#include <cs

uva 10069 DP + 大数加法

代码: #include <iostream>#include <cstdio>#include <cstdlib>#include <algorithm>#include <cstring>#include <cmath>#include <stack>#include <vector>#include <queue>#include <map>#include <cl

uva 10029 HASH + DP

题意: 给一个字典,里面有好多单词。单词可以由增加、删除、变换,变成另一个单词,问能变换的最长单词长度。 解析: HASH+dp 代码: #include <iostream>#include <cstdio>#include <cstdlib>#include <algorithm>#include <cstring>#include <cmath>#inc

poj 3190 优先队列+贪心

题意: 有n头牛,分别给他们挤奶的时间。 然后每头牛挤奶的时候都要在一个stall里面,并且每个stall每次只能占用一头牛。 问最少需要多少个stall,并输出每头牛所在的stall。 e.g 样例: INPUT: 51 102 43 65 84 7 OUTPUT: 412324 HINT: Explanation of the s